var _class, _temp2;

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

import React, { Component } from 'react';

import Delete from '@material-ui/icons/Delete';
import Edit from '@material-ui/icons/Edit';
import Check from '@material-ui/icons/Check';
import Close from '@material-ui/icons/Close';
import AddCircle from '@material-ui/icons/AddCircle';
import Paper from '@material-ui/core/Paper';
import FormControl from '@material-ui/core/FormControl';
import FormGroup from '@material-ui/core/FormGroup';
import FormLabel from '@material-ui/core/FormLabel';
import IconButton from '@material-ui/core/IconButton';

import { EditingState } from '@devexpress/dx-react-grid';
import { Grid, Table, TableEditColumn, TableEditRow, TableHeaderRow } from '@devexpress/dx-react-grid-material-ui';

var AddButton = function AddButton(_ref) {
  var onExecute = _ref.onExecute;
  return React.createElement(
    'div',
    { style: { textAlign: 'left' } },
    React.createElement(
      IconButton,
      { onClick: onExecute, title: 'Add' },
      React.createElement(AddCircle, null)
    )
  );
};

var EditButton = function EditButton(_ref2) {
  var onExecute = _ref2.onExecute;
  return React.createElement(
    IconButton,
    { onClick: onExecute, title: 'Editar' },
    React.createElement(Edit, null)
  );
};

var DeleteButton = function DeleteButton(_ref3) {
  var onExecute = _ref3.onExecute;
  return React.createElement(
    IconButton,
    { onClick: onExecute, title: 'Remover' },
    React.createElement(Delete, null)
  );
};

var CommitButton = function CommitButton(_ref4) {
  var onExecute = _ref4.onExecute;
  return React.createElement(
    IconButton,
    { onClick: onExecute, title: 'Salvar' },
    React.createElement(Check, null)
  );
};

var CancelButton = function CancelButton(_ref5) {
  var onExecute = _ref5.onExecute;
  return React.createElement(
    IconButton,
    { onClick: onExecute, title: 'Cancelar' },
    React.createElement(Close, null)
  );
};

var commandComponents = {
  add: AddButton,
  edit: EditButton,
  delete: DeleteButton,
  commit: CommitButton,
  cancel: CancelButton
};

var Command = function Command(_ref6) {
  var id = _ref6.id,
      onExecute = _ref6.onExecute;

  var CommandButton = commandComponents[id];
  return React.createElement(CommandButton, { onExecute: onExecute });
};

var TableEditableWidget = (_temp2 = _class = function (_Component) {
  _inherits(TableEditableWidget, _Component);

  function TableEditableWidget() {
    var _temp, _this, _ret;

    _classCallCheck(this, TableEditableWidget);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.state = {
      tableLines: (_this.props.value || []).map(function (item, index) {
        return item.index = index;
      })
    }, _this.configureColumns = function (_ref7) {
      var elements = _ref7.elements;
      return elements.reduce(function (acc, item) {
        var name = item.key,
            title = item.title;

        return [].concat(acc, [{ name: name, title: title }]);
      }, []);
    }, _this.commitChanges = function (_ref8) {
      var added = _ref8.added,
          changed = _ref8.changed,
          deleted = _ref8.deleted;


      var tableLines = _this.state.tableLines.slice();

      changed && Object.keys(changed).forEach(function (item, index) {
        changed[index] && Object.keys(changed[index]).map(function (key) {
          return tableLines[index][key] = changed[index][key];
        });
      });

      deleted && deleted.forEach(function (item, index) {
        return tableLines.splice(index, 1);
      });

      added && added.forEach(function (item) {
        return tableLines.push(item);
      });

      tableLines.forEach(function (item, index) {
        return item.index = index;
      });

      _this.props.onChange(tableLines);
      _this.setState({ tableLines: tableLines });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  TableEditableWidget.prototype.render = function render() {
    var _props = this.props,
        schema = _props.schema,
        label = _props.label;
    var tableLines = this.state.tableLines;


    var columns = this.configureColumns(schema);

    return React.createElement(
      'section',
      null,
      React.createElement(
        FormControl,
        { component: 'fieldset' },
        React.createElement(
          FormLabel,
          { component: 'legend', style: { padding: '6px 0 7px' } },
          label
        )
      ),
      React.createElement(
        FormGroup,
        null,
        React.createElement(
          Paper,
          null,
          React.createElement(
            Grid,
            {
              rows: tableLines,
              columns: columns,
              getRowId: function getRowId(row) {
                return row.index;
              }
            },
            React.createElement(EditingState, { onCommitChanges: this.commitChanges }),
            React.createElement(Table, { messages: { noData: 'Sem dados' } }),
            React.createElement(TableHeaderRow, null),
            React.createElement(TableEditRow, null),
            React.createElement(TableEditColumn, {
              width: 100,
              showAddCommand: !schema.disabled,
              showEditCommand: !schema.disabled,
              showDeleteCommand: !schema.disabled,
              commandComponent: Command
            })
          )
        )
      )
    );
  };

  return TableEditableWidget;
}(Component), _class.defaultProps = {
  value: []
}, _temp2);


export default TableEditableWidget;