'use strict';

exports.__esModule = true;

var _class, _temp2;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Delete = require('@material-ui/icons/Delete');

var _Delete2 = _interopRequireDefault(_Delete);

var _Edit = require('@material-ui/icons/Edit');

var _Edit2 = _interopRequireDefault(_Edit);

var _Check = require('@material-ui/icons/Check');

var _Check2 = _interopRequireDefault(_Check);

var _Close = require('@material-ui/icons/Close');

var _Close2 = _interopRequireDefault(_Close);

var _AddCircle = require('@material-ui/icons/AddCircle');

var _AddCircle2 = _interopRequireDefault(_AddCircle);

var _Paper = require('@material-ui/core/Paper');

var _Paper2 = _interopRequireDefault(_Paper);

var _FormControl = require('@material-ui/core/FormControl');

var _FormControl2 = _interopRequireDefault(_FormControl);

var _FormGroup = require('@material-ui/core/FormGroup');

var _FormGroup2 = _interopRequireDefault(_FormGroup);

var _FormLabel = require('@material-ui/core/FormLabel');

var _FormLabel2 = _interopRequireDefault(_FormLabel);

var _IconButton = require('@material-ui/core/IconButton');

var _IconButton2 = _interopRequireDefault(_IconButton);

var _dxReactGrid = require('@devexpress/dx-react-grid');

var _dxReactGridMaterialUi = require('@devexpress/dx-react-grid-material-ui');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var AddButton = function AddButton(_ref) {
  var onExecute = _ref.onExecute;
  return _react2.default.createElement(
    'div',
    { style: { textAlign: 'left' } },
    _react2.default.createElement(
      _IconButton2.default,
      { onClick: onExecute, title: 'Add' },
      _react2.default.createElement(_AddCircle2.default, null)
    )
  );
};

var EditButton = function EditButton(_ref2) {
  var onExecute = _ref2.onExecute;
  return _react2.default.createElement(
    _IconButton2.default,
    { onClick: onExecute, title: 'Editar' },
    _react2.default.createElement(_Edit2.default, null)
  );
};

var DeleteButton = function DeleteButton(_ref3) {
  var onExecute = _ref3.onExecute;
  return _react2.default.createElement(
    _IconButton2.default,
    { onClick: onExecute, title: 'Remover' },
    _react2.default.createElement(_Delete2.default, null)
  );
};

var CommitButton = function CommitButton(_ref4) {
  var onExecute = _ref4.onExecute;
  return _react2.default.createElement(
    _IconButton2.default,
    { onClick: onExecute, title: 'Salvar' },
    _react2.default.createElement(_Check2.default, null)
  );
};

var CancelButton = function CancelButton(_ref5) {
  var onExecute = _ref5.onExecute;
  return _react2.default.createElement(
    _IconButton2.default,
    { onClick: onExecute, title: 'Cancelar' },
    _react2.default.createElement(_Close2.default, null)
  );
};

var commandComponents = {
  add: AddButton,
  edit: EditButton,
  delete: DeleteButton,
  commit: CommitButton,
  cancel: CancelButton
};

var Command = function Command(_ref6) {
  var id = _ref6.id,
      onExecute = _ref6.onExecute;

  var CommandButton = commandComponents[id];
  return _react2.default.createElement(CommandButton, { onExecute: onExecute });
};

var TableEditableWidget = (_temp2 = _class = function (_Component) {
  _inherits(TableEditableWidget, _Component);

  function TableEditableWidget() {
    var _temp, _this, _ret;

    _classCallCheck(this, TableEditableWidget);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, _Component.call.apply(_Component, [this].concat(args))), _this), _this.state = {
      tableLines: (_this.props.value || []).map(function (item, index) {
        return item.index = index;
      })
    }, _this.configureColumns = function (_ref7) {
      var elements = _ref7.elements;
      return elements.reduce(function (acc, item) {
        var name = item.key,
            title = item.title;

        return [].concat(acc, [{ name: name, title: title }]);
      }, []);
    }, _this.commitChanges = function (_ref8) {
      var added = _ref8.added,
          changed = _ref8.changed,
          deleted = _ref8.deleted;


      var tableLines = _this.state.tableLines.slice();

      changed && Object.keys(changed).forEach(function (item, index) {
        changed[index] && Object.keys(changed[index]).map(function (key) {
          return tableLines[index][key] = changed[index][key];
        });
      });

      deleted && deleted.forEach(function (item, index) {
        return tableLines.splice(index, 1);
      });

      added && added.forEach(function (item) {
        return tableLines.push(item);
      });

      tableLines.forEach(function (item, index) {
        return item.index = index;
      });

      _this.props.onChange(tableLines);
      _this.setState({ tableLines: tableLines });
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  TableEditableWidget.prototype.render = function render() {
    var _props = this.props,
        schema = _props.schema,
        label = _props.label;
    var tableLines = this.state.tableLines;


    var columns = this.configureColumns(schema);

    return _react2.default.createElement(
      'section',
      null,
      _react2.default.createElement(
        _FormControl2.default,
        { component: 'fieldset' },
        _react2.default.createElement(
          _FormLabel2.default,
          { component: 'legend', style: { padding: '6px 0 7px' } },
          label
        )
      ),
      _react2.default.createElement(
        _FormGroup2.default,
        null,
        _react2.default.createElement(
          _Paper2.default,
          null,
          _react2.default.createElement(
            _dxReactGridMaterialUi.Grid,
            {
              rows: tableLines,
              columns: columns,
              getRowId: function getRowId(row) {
                return row.index;
              }
            },
            _react2.default.createElement(_dxReactGrid.EditingState, { onCommitChanges: this.commitChanges }),
            _react2.default.createElement(_dxReactGridMaterialUi.Table, { messages: { noData: 'Sem dados' } }),
            _react2.default.createElement(_dxReactGridMaterialUi.TableHeaderRow, null),
            _react2.default.createElement(_dxReactGridMaterialUi.TableEditRow, null),
            _react2.default.createElement(_dxReactGridMaterialUi.TableEditColumn, {
              width: 100,
              showAddCommand: !schema.disabled,
              showEditCommand: !schema.disabled,
              showDeleteCommand: !schema.disabled,
              commandComponent: Command
            })
          )
        )
      )
    );
  };

  return TableEditableWidget;
}(_react.Component), _class.defaultProps = {
  value: []
}, _temp2);
exports.default = TableEditableWidget;
module.exports = exports['default'];